#include <pluginlib/class_list_macros.h>
#include "NodeletDuo.h"

PLUGINLIB_EXPORT_CLASS(autonom_a::NodeletDuo, nodelet::Nodelet);

namespace autonom_a
{
	NodeletDuo::NodeletDuo(ros::NodeHandle &nh, std::string &name) : nh_(nh), name_(name) {}
	NodeletDuo::NodeletDuo() {}
	NodeletDuo::~NodeletDuo() {}
	void NodeletDuo::onInit()
	{
		NODELET_INFO("Initializing nodelet: Duo");
		topic1_sub = nh_.subscribe("topic1", 1000, &NodeletDuo::topicCallback, this);
		topic2_pub = nh_.advertise<Num>("topic2", 1000);
	}

	void NodeletDuo::topicCallback(const Num::ConstPtr& msg)
	{
		Num newMsg;
		newMsg.x = (msg->x);
		newMsg.y = (msg->y) - (msg->x);

		topic2_pub.publish(newMsg);
		
	}
}
